﻿Type=Class
Version=5.51
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
Sub Class_Globals
	Private fx As JFX
	Private Const e  As Double = 2.71828182845905
	Private argX As String
	Private Const evNumber = 1
	Private Const evConstant = 2
	Private Const evFunction = 5
	Private Const evLeftBracket = 6
	Private Const evRightBracket = 7
	Private Const evOperand = 8
	Private Const evElse = 16
	Private i1, one, two, brackets, k, i2 As Short
	Private txresult As TextField
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize
	
End Sub

Public Sub Evaluate(S As String) As String
	Dim Evlt As Double
	Dim opd(200) As Double, op(200) As String
	Dim top1, top2 As Short
	Dim value, x1, x2 As Double
	Dim Si, Sk, S0 As String
	Dim Function_Error As Short = Check_Syntax(S) 
	If Function_Error <> 0 Then
		Return Error_Message(Function_Error)
	End If
	i1 = 0
	i2 = 0
    argX = "x"
    top1 = 0
    top2 = 1
    op(top2) = "("
    S = S & ")"
    k = 1
    Si = "("
	Do While k <= S.Length And top2 > 0
        Next_Token(S)
        Sk = Si
        Si = MidVb(S, i1, i2 - i1 + 1)
        k = i2 + 1
        If IsNum(Si) Then
	        top1 = top1 + 1
	        opd(top1) =  Si.Replace(",", ".")
	        value = opd(top1)
        Else
        	Select Case Si.ToLowerCase
        		Case "("
					top2 = top2 + 1
					op(top2) = "("
        		Case argX, "pi", "e"
        			top1 = top1 + 1
					S0 = Si.ToLowerCase
	        		Select Case S0
        				Case "pi"
							opd(top1) = cPI
        				Case "e"
							opd(top1) = e
        			End Select
					If IsNum(Sk) Then
						top2 = top2 + 1
						op(top2) = "*"
					End If
        		Case Else
        			Do While (top2 > 0) And (op(top2) <> "(") And (op(top2) <> ")") _
        				And (Priority(op(top2)) >= Priority(Si))
            			If top1 >= 2 Then x1 = opd(top1 - 1)
            			x2 = opd(top1)
            			Select Case op(top2).ToLowerCase
            				Case "+": value = x1 + x2
            				Case "-": value = x1 - x2
 		           			Case "~": value = -x2  'unary minus
            				Case "*": value = x1 * x2
            				Case "/"
            					If x2 <> 0 Then
            						value = x1 / x2
            					Else
									Function_Error = 7: Evlt = 0
									Return Error_Message(Function_Error)
								End If
							Case "^"
								If ((x1 < 0) And (x2 <> x2) Or _
            						((x1 = 0) And (x2 = 0))) Then
            						Function_Error = 1: Evlt = 0
									Return Error_Message(Function_Error)
								Else
									value = Power(x1 , x2)
								End If
            				Case "@" 	'logarithm
            					If (x1 > 0) And (x2 > 1) Then
            						value = Logarithm(x1, x2) 
            					Else
            						If x2 = 1 Then
            							value = Logarithm(x1, e)
            						Else
										Function_Error = 2: Evlt = 0
										Return Error_Message(Function_Error)
									End If
								End If
            				Case "sin"
								value = Sin(x2)
            				Case "cos"
								value = Cos(x2)
            				Case "tan"
								If Cos(x2) <> 0 Then
									value = Tan(x2)
            					Else
									Function_Error = 3: Evlt = 0
									Return Error_Message(Function_Error)
            					End If
							Case "asin"
								If (x2 >= -1) And (x2 <= 1) Then
									value = ASin(x2)
								Else
									Function_Error = 5: Evlt = 0
									Return Error_Message(Function_Error)
								End If
            				Case "acos"
								If (x2 >= -1 ) And (x2 <= 1) Then
            						value = ACos(x2) 
            					Else
									Function_Error = 6: Evlt = 0
									Return Error_Message(Function_Error)
            					End If
            				Case "atan"
								value = ATan(x2)
            				Case "sinh"
								value = (Exp(x2) - Exp(-x2)) * 0.5
            				Case "cosh"
								value = (Exp(x2) + Exp(-x2)) * 0.5
            				Case "tanh"
								value = (Exp(x2) - Exp(-x2)) / (Exp(x2) + Exp(-x2))
            				Case "logn"
            					If x2 > 0 Then
            						value = Logarithm(x2, e)
            					Else
									Function_Error = 2: Evlt = 0
									Return Error_Message(Function_Error)
								End If
							Case "log10"
								If x2 > 0 Then
									value = Logarithm(x2, 10)
								Else
									Function_Error = 2: Evlt = 0
									Return Error_Message(Function_Error)
								End If
            				Case "exp"
								value = Exp(x2)
							Case "abs"
								value = Abs(x2)
	            			Case "sqrt"
	            				If x2 >= 0 Then
	            					value = Sqrt(x2)
	            				Else
									Function_Error = 4: Evlt = 0
									Return Error_Message(Function_Error)
								End If
							Case "int"
								value = Floor(x2)
	            			Case "round"
								value = Round(x2)
	            			Case "frac"
								value = x2 - Floor(x2)
						End Select
            			If (MidVb(op(top2), 1, 1).ToLowerCase.CompareTo("a") < 0) Or _
            				((MidVb(op(top2), 1, 1).ToUpperCase.CompareTo(argX) > 0)) _
            				And (op(top2) <> "~") Then 
							top1 = top1 - 1
						End If
            			opd(top1) = value
            			top2 = top2 - 1
        			Loop
       				If top2 > 0 Then
            			If (op(top2) <> "(") Or (Si <> ")") Then
            				top2 = top2 + 1
            				op(top2) = IIF((Sk = "(") And (Si = "-"), "~", Si)
        				Else
            				top2 = top2 - 1
        				End If
        			End If
        	End Select
        End If
	Loop
    Evlt = opd(1)
	Return Evlt
End Sub

private Sub Exp(d As Double) As Double
	Return Power(e, d) 
End Sub

Private Sub Priority(c As String) As Short
	Dim P As Short
    Dim c1 As String = Left(c, 1)
    Select Case c1
        Case "(", ")"
			P = 0     	'Priority 0 : brackets
        Case "+", "-"
			P = 1       'Priority 1 : aditive operators
        Case "~"
			P = 2       'Priority 2 : unary operator
        Case "*", "/"
			P = 3       'Priority 3 : multiplicative operators
        Case "^", "@"
			P = 4       'Priority 4 : exponential operators (a @ b -> log(a), base=b)
        Case Else 	'"a" To "z", "A" To "Z"
			P = 5  		'Priority 5 : math functions, constants
    End Select
    Return P
End Sub

Public Sub Check_Syntax(S As String) As Short
	Dim WithX As Boolean
	Dim Function_Error As Short
	Dim Si, Sk As String
    i1 = 2
    i2 = 1
    argX = IIF(WithX, "x", "")
    Function_Error = IIF(S.trim = "", 17, 0)
    If Function_Error = 17 Then Return Function_Error
    S = "(" & S & ")"
    Si = "("
    k = i2 + 1
    one = 6 ' Lexical_Unit ("(")
    brackets = 1
    Do While k <= S.Length
		Next_Token(S)
        Sk = MidVb(S, i1, i2 - i1 + 1)
        k = i2 + 1
        two = Lexical_Unit(Sk)
        If two = 16 Then
            Function_Error = 16
            Return Function_Error
        End If
        Select Case Sk
            Case "("
				brackets = brackets + 1
            Case ")"
				brackets = brackets - 1
        End Select
        If brackets < 0 Then
			Function_Error = 11
			Return Function_Error
   		End If
 		Select Case one
            Case evNumber
            	If Not ((two = evConstant) Or (two = evLeftBracket) Or _
            		(two = evRightBracket) Or (two = evOperand)) Then Function_Error = 12
            Case evConstant
            	If Not ((two = evLeftBracket) Or (two = evRightBracket) Or (two = evOperand)) Then Function_Error = 12
            Case evFunction
            	If (two <> evLeftBracket) Then Function_Error = 13
            Case evLeftBracket
            	If (two = evRightBracket) Or ((two = evOperand) And (Sk <> "-")) Then Function_Error = 14
            Case evRightBracket
            	If (two <> evOperand) And (two <> evRightBracket) Then Function_Error = 15
            Case evOperand
            	If (two = evRightBracket) Or (two = evOperand) Then Function_Error = 14
            Case evElse
            	Function_Error = 16
        End Select
        If Function_Error > 0 Then Return Function_Error
        Si = Sk
        one = two
    Loop
	If brackets <> 0 Then 
		Function_Error = 11
	End If
	Return Function_Error
End Sub

Private Sub Error_Message(n As Short) As String
	Dim Error_Msg As String
    Select Case n
        Case 0
        	Error_Msg = "No error !"
        Case 1
        	Error_Msg = "Error evaluating power function."
        Case 2
        	Error_Msg = "Error evaluating logarithm. The argument must be > 0."
        Case 3
        	Error_Msg = "Error evaluating tangent."
        Case 4
        	Error_Msg = "Error evaluating square root. The argument must be >= 0."
        Case 5
        	Error_Msg = "Error evaluating arcsine. The argument must be in [-1, 1]."
        Case 6
        	Error_Msg = "Error evaluating arccosine. The argument must be in [-1, 1]."
        Case 7
        	Error_Msg = "Division by zero."
        Case 11
        	Error_Msg = "Unexpected end of parenthesis."
        Case 12
        	Error_Msg = "Operators must be followed by number, constant, function."
        Case 13
        	Error_Msg = "Function must be followed by parenthesis."
        Case 14
        	Error_Msg = "An error occured in evaluation"
        Case 15
        	Error_Msg = "Expression expected."
        Case 16
        	Error_Msg = "Unknown function."
        Case 17
        	Error_Msg = "Enter the value for which you want to evaluate the function."
        Case 18
        	Error_Msg = "An error occured in evaluation"
    End Select
	Return Error_Msg
End Sub

Private Sub Lexical_Unit(c As String) As Short
	Dim lRet As Short
    c = c.ToLowerCase
    If IsNum(c) Then
		lRet = evNumber
    Else
        Select Case c
            Case "e", "pi"
				lRet = evConstant
		Case "sin", "cos", "tan", "asin", "atan", "acos", "sinh", _
			"cosh", "tanh", "logn", "log10", "exp", "abs", "sqrt", _
			"round", "frac",  "int"
            	
				lRet = evFunction
            Case "("
				lRet = evLeftBracket
            Case ")"
				lRet = evRightBracket
            Case "+", "-", "*", "/", "^", "@"
				lRet = evOperand
            Case Else
				lRet = evElse
        End Select
    End If
	Return lRet
End Sub

Private Sub Next_Token(S As String)
	Dim s1, s2 As String
	Dim other_token As Boolean
	Do While MidVb(S, k, 1) = " "
		k = k + 1
	Loop
	i1 = k
	s1 = MidVb(S, k, 1).ToLowerCase
	Do Until other_token Or ((s1 = "(") And (s2 = "(")) Or ((s1 = ")") And (s2 = ")"))
		If k + 1 > S.Length Then 
			s2 = ""
		Else
			s2 = MidVb(S, k + 1, 1).ToLowerCase
		End If
		other_token = (s1 <> s2) And Not (IsNum(s1) And IsNum(s2)) And _
        Not ((s1.CompareTo("a") >= 0) And (s1.CompareTo("z") <= 0) And (s2.CompareTo("a") >= 0) And (s2.CompareTo("z") <= 0))
		k = k + 1
		s1 = s2
	Loop 
	i2 = k - 1
End Sub

Private Sub IsNum(S As String) As Boolean
    Dim IsN As Boolean = IsNumber(S) Or (S = ".") Or (S = ",")
	Return IsN
End Sub

Private Sub Left(Text As String, Length As Int)As String
	If Length>Text.Length Then Length=Text.Length
	Return Text.SubString2(0, Length)
End Sub

Private Sub MidVb(Text As String, Start As Int, Length As Int) As String
	Start = Start -1
	Return Text.SubString2(Start, Start + Length)
End Sub

Private Sub IIF(c As Boolean, TrueRes As Object, FalseRes As Object) As Object
	If c Then Return TrueRes Else Return FalseRes
End Sub